## squirrel3 3.1

=== CMakeLists.txt ===
if(MSVC)
  cmake_minimum_required(VERSION 3.4)
else()
  cmake_minimum_required(VERSION 2.8)
endif()

set(CMAKE_INSTALL_PREFIX "${CMAKE_SOURCE_DIR}" CACHE PATH "")
set(CMAKE_BUILD_TYPE "Release" CACHE STRING "")

project(squirrel C CXX)

include_directories(${CMAKE_SOURCE_DIR}/include)

if(CMAKE_COMPILER_IS_GNUCXX)
  set(SQ_FLAGS -fno-exceptions -fno-strict-aliasing -Wall -Wextra -pedantic -Wcast-qual)

  if(CMAKE_BUILD_TYPE STREQUAL "Release")
    set(SQ_FLAGS ${SQ_FLAGS} -O3)
  elseif(CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
    set(SQ_FLAGS ${SQ_FLAGS} -O3 -g)
  elseif(CMAKE_BUILD_TYPE STREQUAL "MinSizeRel")
    set(SQ_FLAGS ${SQ_FLAGS} -Os)
  elseif(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(SQ_FLAGS ${SQ_FLAGS} -pg -pie -gstabs -g3 -Og)
  endif()

  if(CMAKE_VERSION VERSION_GREATER 3)
    add_compile_options(${SQ_FLAGS})
  else()
    add_definitions(${SQ_FLAGS})
  endif()

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti -std=c++0x")
elseif(MSVC)
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif()

if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  add_definitions(-D_SQ64)
endif()

if(NOT DEFINED INSTALL_BIN_DIR)
  set(INSTALL_BIN_DIR bin)
endif()

if(NOT DEFINED INSTALL_LIB_DIR)
  set(INSTALL_LIB_DIR lib)
endif()

add_subdirectory(squirrel)
add_subdirectory(sqstdlib)
add_subdirectory(sq)

if(NOT WIN32)
  set_target_properties(squirrel sqstdlib PROPERTIES SOVERSION 0 VERSION 0.0.0)
endif()

if(DEFINED INSTALL_INC_DIR)
  set(SQ_PUB_HEADERS include/sqconfig.h
                     include/sqstdaux.h
                     include/sqstdblob.h
                     include/sqstdio.h
                     include/sqstdmath.h
                     include/sqstdstring.h
                     include/sqstdsystem.h
                     include/squirrel.h)
  install(FILES ${SQ_PUB_HEADERS} DESTINATION ${INSTALL_INC_DIR})
endif()

=== sq/CMakeLists.txt ===
add_executable(sq sq.c)
set_target_properties(sq PROPERTIES LINKER_LANGUAGE C)
target_link_libraries(sq squirrel sqstdlib)
install(TARGETS sq RUNTIME DESTINATION ${INSTALL_BIN_DIR})

if(NOT DEFINED DISABLE_STATIC)
  add_executable(sq_static sq.c)
  set_target_properties(sq_static PROPERTIES LINKER_LANGUAGE C)
  target_link_libraries(sq_static squirrel_static sqstdlib_static)
  install(TARGETS sq_static RUNTIME DESTINATION ${INSTALL_BIN_DIR})
endif()

if(DEFINED LONG_OUTPUT_NAMES)
  set_target_properties(sq PROPERTIES OUTPUT_NAME squirrel3)

  if(NOT DEFINED DISABLE_STATIC)
    set_target_properties(sq_static PROPERTIES OUTPUT_NAME squirrel3_static)
  endif()
endif()

if(CMAKE_COMPILER_IS_GNUCXX AND (NOT DEFINED DISABLE_STATIC))
  set_target_properties(sq_static PROPERTIES COMPILE_FLAGS "-static -Wl,-static")
endif()

=== sqstdlib/CMakeLists.txt ===
set(SQSTDLIB_SRC sqstdaux.cpp
                 sqstdblob.cpp
                 sqstdio.cpp
                 sqstdmath.cpp
                 sqstdrex.cpp
                 sqstdstream.cpp
                 sqstdstring.cpp
                 sqstdsystem.cpp)

add_library(sqstdlib SHARED ${SQSTDLIB_SRC})
target_link_libraries(sqstdlib squirrel)
install(TARGETS sqstdlib RUNTIME DESTINATION ${INSTALL_BIN_DIR}
                         LIBRARY DESTINATION ${INSTALL_LIB_DIR}
                         ARCHIVE DESTINATION ${INSTALL_LIB_DIR})

if(NOT DEFINED DISABLE_STATIC)
  add_library(sqstdlib_static STATIC ${SQSTDLIB_SRC})
  install(TARGETS sqstdlib_static ARCHIVE DESTINATION ${INSTALL_LIB_DIR})
endif()

if(DEFINED LONG_OUTPUT_NAMES)
  set_target_properties(sqstdlib PROPERTIES OUTPUT_NAME sqstdlib3)

  if(NOT DEFINED DISABLE_STATIC)
    set_target_properties(sqstdlib_static PROPERTIES OUTPUT_NAME sqstdlib3_static)
  endif()
endif()

=== sqstdlib/Makefile ===
SQUIRREL= ..


OUT= $(SQUIRREL)/lib/libsqstdlib.a
INCZ= -I$(SQUIRREL)/include -I. -Iinclude

OBJS= \
	sqstdblob.o \
	sqstdio.o \
	sqstdstream.o \
	sqstdmath.o \
	sqstdsystem.o \
	sqstdstring.o \
	sqstdaux.o \
	sqstdrex.o

SRCS= \
	sqstdblob.cpp \
	sqstdio.cpp \
	sqstdstream.cpp \
	sqstdmath.cpp \
	sqstdsystem.cpp \
	sqstdstring.cpp \
	sqstdaux.cpp \
	sqstdrex.cpp


sq32:
	gcc -O2 -fno-exceptions -fno-rtti -Wall -fno-strict-aliasing -c $(SRCS) $(INCZ)
	ar rc $(OUT) *.o
	rm *.o

sqprof:
	gcc -O2 -pg -fno-exceptions -fno-rtti -pie -gstabs -g3 -Wall -fno-strict-aliasing -c $(SRCS) $(INCZ)
	ar rc $(OUT) *.o
	rm *.o

sq64:
	gcc -O2 -m64 -fno-exceptions -D_SQ64 -fno-rtti -Wall -fno-strict-aliasing -c $(SRCS) $(INCZ)
	ar rc $(OUT) *.o
	rm *.o

=== squirrel/CMakeLists.txt ===
set(SQUIRREL_SRC sqapi.cpp
                 sqbaselib.cpp
                 sqclass.cpp
                 sqcompiler.cpp
                 sqdebug.cpp
                 sqfuncstate.cpp
                 sqlexer.cpp
                 sqmem.cpp
                 sqobject.cpp
                 sqstate.cpp
                 sqtable.cpp
                 sqvm.cpp)

add_library(squirrel SHARED ${SQUIRREL_SRC})
install(TARGETS squirrel RUNTIME DESTINATION ${INSTALL_BIN_DIR}
                         LIBRARY DESTINATION ${INSTALL_LIB_DIR}
                         ARCHIVE DESTINATION ${INSTALL_LIB_DIR})

if(NOT DEFINED DISABLE_STATIC)
  add_library(squirrel_static STATIC ${SQUIRREL_SRC})
  install(TARGETS squirrel_static ARCHIVE DESTINATION ${INSTALL_LIB_DIR})
endif()

if(DEFINED LONG_OUTPUT_NAMES)
  set_target_properties(squirrel PROPERTIES OUTPUT_NAME squirrel3)

  if(NOT DEFINED DISABLE_STATIC)
    set_target_properties(squirrel_static PROPERTIES OUTPUT_NAME squirrel3_static)
  endif()
endif()

=== squirrel/Makefile ===
SQUIRREL= ..


OUT= $(SQUIRREL)/lib/libsquirrel.a
INCZ= -I$(SQUIRREL)/include -I. -Iinclude
DEFS=
LIB=

OBJS= \
	sqapi.o \
	sqbaselib.o \
	sqfuncstate.o \
	sqdebug.o \
	sqlexer.o \
	sqobject.o \
	sqcompiler.o \
	sqstate.o \
	sqtable.o \
	sqmem.o \
	sqvm.o \
	sqclass.o

SRCS= \
	sqapi.cpp \
	sqbaselib.cpp \
	sqfuncstate.cpp \
	sqdebug.cpp \
	sqlexer.cpp \
	sqobject.cpp \
	sqcompiler.cpp \
	sqstate.cpp \
	sqtable.cpp \
	sqmem.cpp \
	sqvm.cpp \
	sqclass.cpp



sq32:
	gcc -O2 -fno-exceptions -fno-rtti -Wall -fno-strict-aliasing -c $(SRCS) $(INCZ) $(DEFS)
	ar rc $(OUT) *.o
	rm *.o

sqprof:
	gcc -O2 -pg -fno-exceptions -fno-rtti -pie -gstabs -g3 -Wall -fno-strict-aliasing -c $(SRCS) $(INCZ) $(DEFS)
	ar rc $(OUT) *.o
	rm *.o

sq64:
	gcc -O2 -m64 -D_SQ64 -fno-exceptions -fno-rtti -Wall -fno-strict-aliasing -c $(SRCS) $(INCZ) $(DEFS)
	ar rc $(OUT) *.o
	rm *.o

=== debian/changelog ===
squirrel3 (3.1-8.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1113540)

 -- Adrian Bunk <bunk@debian.org>  Sun, 26 Oct 2025 22:12:22 +0200

squirrel3 (3.1-8.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Cherry-pick upstream commit as 03-fix-buffer-overflow.diff
    Closes: #1014539, CVE-2022-30292

 -- Matthias Geiger <werdahias@riseup.net>  Mon, 13 May 2024 14:59:34 +0200

squirrel3 (3.1-8.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix watch file to look for Github tags instead of releases 
  * Build-depend on tex-gyre (Closes: #997441)

 -- Matthias Geiger <werdahias@riseup.net>  Mon, 29 Apr 2024 23:39:09 +0200

squirrel3 (3.1-8) unstable; urgency=medium

  * Change build dependency from texlive-generic-extra to
    texlive-plain-generic (Closes: #933589).
  * Upgrade to debhelper compat level 12 (no changes).
  * Upgrade to Standards-Version 4.4.0 (no changes).

 -- Fabian Wolff <fabi.wolff@arcor.de>  Thu, 01 Aug 2019 15:01:06 +0200

squirrel3 (3.1-7) unstable; urgency=medium

  * Revert upgrade to debhelper compat level 12.
  * Update meta-information of 02-sphinx-ext.patch.

 -- Fabian Wolff <fabi.wolff@arcor.de>  Wed, 20 Mar 2019 20:37:02 +0100

squirrel3 (3.1-6) unstable; urgency=medium

  * Update Vcs-Git and Vcs-Browser fields in debian/control.
  * Add patch 02-sphinx-ext.patch to disable the pngmath Sphinx
    extension (Closes: #923012).
  * Add Applied-Upstream field to header of patch
    01-fix-spelling-errors.patch.
  * Upgrade to Standards-Version 4.3.0 (no changes).
  * Upgrade to debhelper compat level 12.

 -- Fabian Wolff <fabi.wolff@arcor.de>  Sun, 03 Mar 2019 01:37:29 +0100

squirrel3 (3.1-5) unstable; urgency=medium

  * Update debian/copyright.
  * Set Priority to "optional" in debian/control.
  * Upgrade to Standards-Version 4.1.0 in debian/control.
  * Upgrade to compat level 10.
  * Adjust Multi-Arch information in debian/control.
  * Add build-dependency on latexmk (Closes: #872264).
  * No longer modify generated PDFs in debian/rules (pdflatex should
    automatically build them reproducibly by now).

 -- Fabian Wolff <fabi.wolff@arcor.de>  Sun, 17 Sep 2017 21:31:30 +0200

squirrel3 (3.1-4) unstable; urgency=medium

  * Delete libsquirrel3-0.symbols.amd64 (Closes: #831210).
  * Modify Lintian override to apply to all architectures.

 -- Fabian Wolff <fabi.wolff@arcor.de>  Fri, 22 Jul 2016 13:43:59 +0200

squirrel3 (3.1-3) unstable; urgency=medium

  * Add Vcs-Git and Vcs-Browser fields to debian/control.
  * Fix FTBFS with new sphinx version by adding texlive-generic-extra
    to build dependencies in debian/control (Closes: #828963).

 -- Fabian Wolff <fabi.wolff@arcor.de>  Wed, 29 Jun 2016 16:08:58 +0200

squirrel3 (3.1-2) unstable; urgency=medium

  * Upgrade to Standards version 3.9.8 (no changes).
  * Start short description lines with minuscules in debian/control
    (Closes: #821029).
  * Override Lintian false positive in libsquirrel3-0.
  * Make sure sphinx-build never performs network connections.
  * Improve reproducibility of PDF documents.
  * Set "Multi-Arch: foreign" for -dev package (Closes: #820529).
  * Add configuration file for git-buildpackage (debian/gbp.conf).

 -- Fabian Wolff <fabi.wolff@arcor.de>  Sun, 24 Apr 2016 21:07:47 +0200

squirrel3 (3.1-1) unstable; urgency=low

  * Initial release. Closes: #651195

 -- Fabian Wolff <fabi.wolff@arcor.de>  Sun, 03 Apr 2016 20:14:18 +0200

=== debian/control ===
Source: squirrel3
Maintainer: Fabian Wolff <fabi.wolff@arcor.de>
Section: interpreters
Priority: optional
Build-Depends: debhelper-compat (= 12),
               cmake,
               python3-sphinx | python-sphinx,
               texlive,
               texlive-latex-extra,
               texlive-plain-generic,
               latexmk,
               tex-gyre,
Standards-Version: 4.4.0
Homepage: http://squirrel-lang.org/
Vcs-Git: https://salsa.debian.org/wolff-guest/squirrel3.git/
Vcs-Browser: https://salsa.debian.org/wolff-guest/squirrel3

Package: squirrel3
Architecture: any
Multi-Arch: no
Depends: libsquirrel3-0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: lightweight, high-level, embeddable programming language
 Squirrel is a high-level imperative, object-oriented programming
 language, designed to be a lightweight scripting language that fits
 in the size, memory bandwidth, and real-time requirements of
 applications like video games.
 .
 This package contains the Squirrel command line interpreter and
 bytecode compiler.

Package: libsquirrel3-0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: runtime libraries for the Squirrel programming language
 Squirrel is a high-level imperative, object-oriented programming
 language, designed to be a lightweight scripting language that fits
 in the size, memory bandwidth, and real-time requirements of
 applications like video games.
 .
 This package contains runtime libraries. You shouldn't have to
 install it manually.

Package: libsquirrel-dev
Architecture: any
Multi-Arch: no
Section: libdevel
Depends: libsquirrel3-0 (= ${binary:Version}),
         ${misc:Depends}
Description: development files for the Squirrel programming language
 Squirrel is a high-level imperative, object-oriented programming
 language, designed to be a lightweight scripting language that fits
 in the size, memory bandwidth, and real-time requirements of
 applications like video games.
 .
 This package contains developer resources for using the Squirrel
 library. Install it if you are developing programs that use the
 Squirrel API.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%squirrel-$1.tar.gz%" \
             https://github.com/albertodemichelis/squirrel/tags \
             (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
